'use strict';
var db = require("org/arangodb").db;
var fs = require("fs"),
    directory = applicationContext.foxxFilename("attachments");
var console = require("console");

function createCollection(name) {
  var collectionName = applicationContext.collectionName(name);
  if (db._collection(collectionName) === null) {
    db._create(collectionName);
  } else if (applicationContext.isProduction) {
    console.warn("collection '%s' already exists. Leaving it untouched.", collectionName);
  }
}

function createFullIndex(name, fields) {
  var collectionName = applicationContext.collectionName(name);
  var col = db._collection(collectionName);
  if(col === null)
  	return;
  var lstIdx = col.getIndexes();
  for(var i = 0; i < lstIdx.length; i++) {
  	if(lstIdx[i].type == "fulltext")
  		return;
  }
  try {
  	col.ensureFulltextIndex(fields);
  } catch(e) {
  	console.log("%j", e);
  }
}

createCollection("issue");
createCollection("project");
createCollection("category");
createCollection("attachment");
createCollection("reply");
createCollection("status");
createCollection("priority");
createCollection("sitsno");

if (!fs.isDirectory(directory)) {
  fs.makeDirectory(directory);
}

createFullIndex("issue", ["description"]);
createFullIndex("reply", ["text"]);

